import os

import logging

from unip.mlcmp.config import MODEL_S3_COPY_BUCKET_PATH, MODEL_S3_COPY_LOCAL_PATH, MODEL_S3_BUCKET_NAME
from unip.mlcmp.s3 import model_s3_client


def download_model():
    bucket_name = MODEL_S3_BUCKET_NAME
    bucket_path = MODEL_S3_COPY_BUCKET_PATH

    recursively = True
    logging.info(f'Downloading files from bucket {bucket_name} with bucket path {bucket_path} recursively = {recursively}')

    for item in model_s3_client.list_objects(bucket_name, prefix=bucket_path, recursive=recursively):
        rel_path = os.path.relpath(item.object_name, bucket_path)
        full_local_path = os.path.join(MODEL_S3_COPY_LOCAL_PATH, rel_path)
        logging.warning(item.object_name + ' - ' + full_local_path)
        model_s3_client.fget_object(bucket_name, item.object_name, full_local_path)


if __name__ == "__main__":
    download_model()
